"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

const _ = require(`lodash`);

const crypto = require(`crypto`);

const path = require(`path`);

function onCreateNode(_x) {
  return _onCreateNode.apply(this, arguments);
}

function _onCreateNode() {
  _onCreateNode = (0, _asyncToGenerator2.default)(function* ({
    node,
    actions,
    loadNodeContent,
    createNodeId
  }) {
    function transformObject(obj, id, type) {
      const objStr = JSON.stringify(obj);
      const contentDigest = crypto.createHash(`md5`).update(objStr).digest(`hex`);
      const jsonNode = Object.assign({}, obj, {
        id,
        children: [],
        parent: node.id,
        internal: {
          contentDigest,
          type
        }
      });
      createNode(jsonNode);
      createParentChildLink({
        parent: node,
        child: jsonNode
      });
    }

    const createNode = actions.createNode,
          createParentChildLink = actions.createParentChildLink; // We only care about JSON content.

    if (node.internal.mediaType !== `application/json`) {
      return;
    }

    const content = yield loadNodeContent(node);
    const parsedContent = JSON.parse(content);

    if (_.isArray(parsedContent)) {
      parsedContent.forEach((obj, i) => {
        transformObject(obj, obj.id ? obj.id : createNodeId(`${node.id} [${i}] >>> JSON`), _.upperFirst(_.camelCase(`${node.name} Json`)));
      });
    } else if (_.isPlainObject(parsedContent)) {
      transformObject(parsedContent, parsedContent.id ? parsedContent.id : createNodeId(`${node.id} >>> JSON`), _.upperFirst(_.camelCase(`${path.basename(node.dir)} Json`)));
    }
  });
  return _onCreateNode.apply(this, arguments);
}

exports.onCreateNode = onCreateNode;